SystemOrganization addCategory: #ConfigurationOfRatPack!

Object subclass: #ConfigurationOfRatPack
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfRatPack'!

!ConfigurationOfRatPack class methodsFor: 'development support' stamp: 'tfel 2/1/2012 09:21'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfRatPack class methodsFor: 'private' stamp: 'tfel 2/1/2012 09:21'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfRatPack class methodsFor: 'private' stamp: 'tfel 2/1/2012 09:21'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfRatPack class methodsFor: 'private' stamp: 'tfel 2/1/2012 09:21'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfRatPack class methodsFor: 'metacello tool support' stamp: 'tfel 2/1/2012 09:21'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfRatPack class methodsFor: 'loading' stamp: 'tfel 2/1/2012 09:21'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfRatPack class methodsFor: 'loading' stamp: 'tfel 2/1/2012 09:21'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfRatPack class methodsFor: 'loading' stamp: 'tfel 2/1/2012 09:21'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfRatPack class methodsFor: 'accessing' stamp: 'tfel 2/1/2012 09:21'!
project

	^self new project! !

!ConfigurationOfRatPack class methodsFor: 'development support' stamp: 'tfel 2/1/2012 09:21'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfRatPack methodsFor: 'baselines' stamp: 'tfel 2/1/2012 09:25'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/RatPack'.
		spec package: 'RatPack'.
		spec project: 'KomHttpServer' with: [
				spec
					className: 'ConfigurationOfKomHttpServer';
					file: 'ConfigurationOfKomHttpServer';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec group: 'default' with: #('RatPack' ). ].

	spec for: #squeak do: [
		spec package: 'VB-Regex' with: [
			spec repository: 'http://www.squeaksource.com/Regex' ]].
! !

!ConfigurationOfRatPack methodsFor: 'symbolic versions' stamp: 'tfel 2/1/2012 09:21'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfRatPack methodsFor: 'accessing' stamp: 'tfel 2/1/2012 09:21'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfRatPack methodsFor: 'versions' stamp: 'tfel 2/1/2012 09:26'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ''.
		spec author: 'tfel'.
		spec timestamp: '2/1/2012 09:21'.
		spec project: 'KomHttpServer' with: '1.0.9'.
		spec package: 'RatPack' with: 'RatPack-tfel.2'].

	spec for: #squeak do: [
		spec package: 'VB-Regex' with: 'VB-Regex-damienpollet.17'].
! !
